// Quelques exemples de programmation
// orientée objet en JS

// Ouvrir la console du navigateur pour voir ce que
// ça donne

// 1er type d'objets : les objets "litteraux" ou "statiques"
// ou "singleton". Ce sont des objets qu'on n'instancie pas
// on les crée tels quels. PROPRIETE : VALEUR
let p1 = {
  nom: "buffa",
  prenom: "Michel"
};

let p2 = {
  nom: "Grin",
  prenom: "Richard",
  getDescription: function() {
    return "Je m'appelle " + this.prenom + " " + this.nom;
  },
  getFullDescription() {
    return this.getDescription() + " et je suis un chaud lapin";
  }
};

p3 = {};
p3.titre = "Joker";
p3.acteur = "Johaquin Phoenix";
p3.univers = "Batman";

// Tester directement dans la console du browser en tapant
// p1.nom, p2.getDescription() etc.

// 2ème approche : les classes !

class Personne {
  // pas obligatoire de déclarer les attributs
  constructor(nom, prenom, age, hobby) {
    this.nom = nom;
    this.prenom = prenom;
    this.age = age;
    // donner une valeur par défaut si le param
    // hobby n'a pas été passé
    this.hobby = hobby || " pas de hobby";
  }
  // PLUS JAMAIS LE MOT CLE "function" !!!
  // on fait des METHODE
  getDescription() {
    return "je m'appelle " + this.prenom + " " 
    + this.nom + " et j'ai " 
    + this.age + " et mon hobby préféré est : " 
    + this.hobby;
    ;
  }
}

p3 = new Personne("Buffa", "Michel", 54, "Guitare");
p4 = new Personne("Grin", "Richard", 67);

// Héritage
class Directeur extends Personne {
    constructor(nom, prenom, age, hobby, salaire) {
        super(nom, prenom, age, hobby);
        this.salaire = "1000000";
    }
    getDescription() {
        return super.getDescription() 
        + " salaire : " + this.salaire;
    }
}

// Exemple : affichage de restaurants dans un tableau HTML
window.onload = init;
function init() {
    afficherRestaurantsDansTableau();
}

let restaurants = [
    {
        nom:"Tacos de Lyon",
        cuisine:"Mexicano/franco/marocaine"
    },
    {
        nom:"Mac Do",
        cuisine:"Burger"
    },
    {
        nom:"Pizza Hut",
        cuisine:"Pizza"
    }
];
ne gro
function afficherRestaurantsDansTableau() {
    restaurants.forEach(r => {
        // r est le restaurant courant
        console.log(r.nom);

        // 0 - on selectionne le tbody et on supprime les
        // lignes
        let tbody = document.querySelector("#tbodyRestaurants");
        tbody.innerHTML = "";

        // 1 on selectionne la table du tableau
        let table = document.querySelector("table");

        // Utilisation de l'API HTML5 sur les tables
        let ligne = table.insertRow();
        ligne.innerHTML ="<td>" + r.nom + "</td>" 
            + "<td>" + r.cuisine + "</td>";
    });
}

